import { F as FormContext, j as jsxRuntimeExports, I as InputWrapper, c as createKey, E as ErrorMessages } from "../../index-bc51b552.js";
import { C, a } from "../../index-bc51b552.js";
import { Form, InputGroup } from "react-bootstrap";
import { useState, useContext, useEffect } from "react";
function Check({ validMessage, invalidMessage, wrapperClassName, ...props }) {
  const [Messages, setMessages] = useState();
  const formContext = useContext(FormContext);
  useEffect(() => {
    const messages = formContext.getError("messages");
    if (messages === void 0) {
      setMessages(void 0);
      return;
    }
    if (props.name && messages[props.name]) {
      setMessages({ ...{}, ...messages[props.name] });
    } else {
      setMessages(void 0);
    }
  }, [formContext.getError("messages")]);
  return /* @__PURE__ */ jsxRuntimeExports.jsxs(
    InputWrapper,
    {
      label: props.label,
      required: props.required,
      name: props.name,
      feedbackMessage: false,
      className: wrapperClassName,
      children: [
        /* @__PURE__ */ jsxRuntimeExports.jsx(
          Form.Check,
          {
            ...props,
            id: props.id || createKey(),
            isInvalid: props.isInvalid || (Messages ? true : false),
            className: (props.className || "") + (props.isInvalid || (Messages ? true : false) ? " border-danger" : "")
          }
        ),
        validMessage && /* @__PURE__ */ jsxRuntimeExports.jsx("div", { className: "ms-2 text-success", children: /* @__PURE__ */ jsxRuntimeExports.jsx("ul", { children: validMessage.map(
          (mes) => /* @__PURE__ */ jsxRuntimeExports.jsx("li", { children: mes }, mes)
        ) }) }),
        /* @__PURE__ */ jsxRuntimeExports.jsxs("div", { className: "ms-2 mb-2 text-danger", children: [
          invalidMessage && /* @__PURE__ */ jsxRuntimeExports.jsx("ul", { className: "mb-0", children: invalidMessage.map(
            (mes) => /* @__PURE__ */ jsxRuntimeExports.jsx("li", { children: mes }, mes)
          ) }),
          Messages && /* @__PURE__ */ jsxRuntimeExports.jsx(ErrorMessages, { messages: Messages })
        ] })
      ]
    }
  );
}
function Select({
  label,
  validMessage,
  invalidMessage,
  beforeText,
  afterText,
  wrapperClassName,
  pleaseOption = true,
  pleaseOptionMessage = "選択してください",
  ...props
}) {
  var _a, _b;
  const [Messages, setMessages] = useState();
  const formContext = useContext(FormContext);
  useEffect(() => {
    const messages = formContext.getError("messages");
    if (messages === void 0) {
      setMessages(void 0);
      return;
    }
    if (props.name && messages[props.name]) {
      setMessages({ ...{}, ...messages[props.name] });
    } else {
      setMessages(void 0);
    }
  }, [formContext.getError("messages")]);
  return /* @__PURE__ */ jsxRuntimeExports.jsx(
    InputWrapper,
    {
      label,
      required: props.required,
      name: props.name,
      feedbackMessage: false,
      className: wrapperClassName,
      children: /* @__PURE__ */ jsxRuntimeExports.jsxs(InputGroup, { children: [
        beforeText && (Array.isArray(beforeText) ? beforeText.map((node) => /* @__PURE__ */ jsxRuntimeExports.jsx(InputGroup.Text, { children: node })) : /* @__PURE__ */ jsxRuntimeExports.jsx(InputGroup.Text, { children: beforeText })),
        /* @__PURE__ */ jsxRuntimeExports.jsxs(
          Form.Select,
          {
            ...props,
            placeholder: props.placeholder || label,
            title: props.title || label,
            isInvalid: props.isInvalid || (Messages ? true : false),
            className: (props.className || "") + (props.isInvalid || (Messages ? true : false) ? " border-danger" : ""),
            children: [
              pleaseOption && /* @__PURE__ */ jsxRuntimeExports.jsx("option", { label: pleaseOptionMessage, className: "d-none" }),
              props.children
            ]
          }
        ),
        validMessage && /* @__PURE__ */ jsxRuntimeExports.jsx(Form.Control.Feedback, { className: "ms-2", children: /* @__PURE__ */ jsxRuntimeExports.jsx("ul", { children: validMessage.map(
          (mes) => /* @__PURE__ */ jsxRuntimeExports.jsx("li", { children: mes }, mes)
        ) }) }),
        (invalidMessage || ((_a = formContext.Error) == null ? void 0 : _a.messages) && props.name && !Array.isArray(formContext.Error.messages) && formContext.Error.messages[props.name]) && /* @__PURE__ */ jsxRuntimeExports.jsxs(Form.Control.Feedback, { type: "invalid", className: "ms-2 mb-2", children: [
          invalidMessage && /* @__PURE__ */ jsxRuntimeExports.jsx("ul", { className: "mb-0", children: invalidMessage.map(
            (mes) => /* @__PURE__ */ jsxRuntimeExports.jsx("li", { children: mes }, mes)
          ) }),
          ((_b = formContext.Error) == null ? void 0 : _b.messages) && props.name && !Array.isArray(formContext.Error.messages) && formContext.Error.messages[props.name] && /* @__PURE__ */ jsxRuntimeExports.jsx(ErrorMessages, { messages: formContext.Error.messages[props.name] })
        ] }),
        afterText && (Array.isArray(afterText) ? afterText.map((node) => /* @__PURE__ */ jsxRuntimeExports.jsx(InputGroup.Text, { children: node })) : /* @__PURE__ */ jsxRuntimeExports.jsx(InputGroup.Text, { children: afterText }))
      ] })
    }
  );
}
export {
  Check,
  C as Control,
  ErrorMessages,
  a as FormWrapper,
  InputWrapper,
  Select
};
